package com.ruoyi.web.work.domain.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;

import javax.validation.constraints.Pattern;
import java.util.List;

/**
 * @author lsw
 * @date 2024-06-07
 */
@Data
@Accessors(chain = true)
public class PositionQueryDto {

    @ApiModelProperty(value = "企业id")
    private Long enterpriseId;

    @ApiModelProperty(value = "类型分类")
    private Integer type;

    @ApiModelProperty(value = "职位名称")
    private String title;

    @ApiModelProperty(value = "地区id")
    private Long regionId;

    @ApiModelProperty(value = "职位分类id")
    private Long positionId;

    @ApiModelProperty(value = "经度")
    private String longitude;

    @ApiModelProperty(value = "维度")
    private String latitude;

    @ApiModelProperty(value = "工作经验 [1年以内,5-10年]")
    private List<String> experience;

    @ApiModelProperty(value = "薪资待遇")
    private String salary;

    private Integer min;

    private Integer max;

    @Pattern(regexp = "^(id|distance)$", message = "orderBy 参数值只能是 id 或 distance")
    private String orderBy = "id";

}
